###############################################################################
#
#	Command Definition File for the Command_App tkCoLa framework.
#	This file is a sample template to base more complicated and
#	useful structures on.
#
#	Jason McDermott, August 16 2001
#	http://www.jasonya.com/tkcola
#	tkcola@jasonya.com
#
###############################################################################

#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
# Set a variable to make the Tk config
#	options for a pop-up menu easy
#	to access.
#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
var |_pop_config |{'font':bold,'relief':'raised',
			$ 'border':2, 'width':20}
			
#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
# Main Application Window Definition
#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
command_set |main
	#.................................................
	# Start a row to hold menu definitions
	#.................................................
	row |Menu_Row ||0 |0
	
	    #.................................................
	    # The following is a simple menu defintion
	    #	followed by a list of menu items.
	    #.................................................
	    menu |File
		    menu_item |Load File ||open$"Load File" |Alt-o
		    menu_item |Save File ||.save_file |Alt-s
		    menu_item |Save File As... ||open$"Save As..." |Alt-S
		    menu_item |Close ||.close |Alt-q
		    
	    #.................................................
	    # The following is a menu defintion which gets
	    #	its menu items from items in a group
	    #	defined below. Currently is called by
	    #	a frame item definition.
	    #.................................................	
	    frame |function_menu |manager.menu_init$menu_groups=('Important Functions',),
			    $ menu_title="Functions", tearoff=1
			    
	    #.................................................
	    # Place a "Help" button at the right of the menu bar
	    #.................................................
	    button |Help |open$"Help Window"
			    
	#.................................................
	# Start a column to hold the body of the program
	#.................................................		
	column |Body |_top
	    #.................................................
	    # The frame definition calls the routine in the
	    #	parent application to fill it with 
	    #	something, in this case a Tk Canvas.
	    #.................................................
	    frame |body_canvas |.make_canvas

#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
# Load File Dialog Definition
#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
command |Load File |.load_file
	#.................................................
	# Place a file selection widget (for opening files)
	#.................................................
	open_file |file |file_open
	
	#.................................................
	# Use the built-in buttons for the open file widget
	#.................................................
	insert_component |_fopen_bar

#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
# Save As... Dialog Definition
#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
command |Save As... |.save_file
	#.................................................
	# Place a file selection widget (for saving files)
	#.................................................
	save_file |file |file_save
	
	#.................................................
	# Use the built-in buttons for the save file widget
	#.................................................
	insert_component |_fsave_bar	
	
#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
# Help Dialog ;) Definition
#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
command_set |Help Window ||?
	#.................................................
	# Print some text to tell the user what we think.
	#.................................................
	text |Fat Chance! Write a real program.
	
	#.................................................
	# Here we use a built-in definition that gives
	#	a simple close bar to close the window.
	#.................................................
	insert_component |_close_bar

#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
# In the group range(s) below we define some 
#	very IMPORTANT functions that we want
#	our user to be able to access.
#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
group_range |Important Functions
command |Set Window Title |._set_wintitle ||Ctrl-t
	entry |title |New Window Title |s |Stupid Window
	insert_component |_simple_bar

command |Draw Sumpin |.draw_sumpin ||d
	label |Choose a shape, location and size.
	label |To change colors click the Color button.
	row |A |_top
	text |Draw What?
	pop |what |What |i ||1
		menu_item |Clear Canvas |0
		menu_item |Draw Square |1
		menu_item |Draw Circle |2
		add_tk_config |$_pop_config
		
	row |B |_top
	entry |xloc |X/Y Location X: |i |250
	entry |yloc ||i |250
	
	row |C |_top
	col ||C
	entry |size |Size |i |20
	rebutton |color |Color
		$ |manager_window$command_title='_Color_Picker',
		$ window_config='def', data=option |s |red |no
		add_tk_config |width:14
		color_default
	insert_component |_simple_bar
	
