# Default Components and Commands for tkCoLa v1.0
#
#	This file will be loaded before every
#		specific tkCoLa command file
#		so all of the commands here
#		will be accessible.
#
#		To maintain a naming convention
#		all of the components and command
#		titles here are preceded with an
#		underscore, "_", and will have no
#		spaces in their titles.
#
#


###################################################################
#
#	Control Button Bar Definitions
#		Include one of these (or one like
#		them) in each command to allow the
#		user to interact with the command.
#
###################################################################

# Simply an OK button
component |_ok_bar
	column |__command_bar |_top | | |bottom
	row | |__command_bar |5
	ok_button
		bind_top |Ret |ok
	set_tk_config |font:bold
	row |__rest |_top |||top
	column ||__rest

# Simply a Close button which doesn't execute a command
component |_close_bar
	column |__command_bar |_top | | |bottom
	row | |__command_bar |5
	cancel_button |Close
		bind_top |Return |cancel
	set_tk_config |font:bold
	row |__rest |_top |||top
	column ||__rest

# Simply a Close button which executes a command
component |_closeok_bar
	column |__command_bar |_top | | |bottom
	row | |__command_bar |5
	ok_button |Close
		bind_top |Return |ok
	set_tk_config |font:bold
	row |__rest |_top |||top
	column ||__rest

# Ok and Cancel buttons
component |_simple_bar
	add_tk_config |font:bold
	column |__command_bar |_top | | |bottom
	row | |__command_bar |5
	ok_button
		bind_top |Return |ok
	cancel_button
		bind_top |Esc |cancel
	row |__rest |_top |||top
	column ||__rest

# Ok, Apply, and Cancel buttons
component |_command_bar
	column |__command_bar |_top | | |bottom
	row |__command_row |__command_bar |5
	ok_button
		bind_top |Return |ok
	apply_button
	cancel_button
		bind_top |Esc |cancel
	row |__rest |_top |||top
	column ||__rest

###################################################################
#
#	command _Color_Picker
#
#	Generic Window for allowing users to
#		choose colors by pressing
#		a button in the calling command
#		that opens this window.
#
#		To invoke this window from a command
#		use the following code with specific
#		button label and variable name (brackets):
#
#	rebutton |[color] |[Button Label]
#		$ |manager_window$command_title='_Color_Picker',
#		$ window_config='def', data=option |string |black |no
#
#		See tkCoLa documentation for an explanation
#			of the command wiring in this case.
#		
###################################################################

command |_Color_Picker |command_return_object$self.data
	default_callback |command_default_object$self.data
	frame |color_picker |Color_Picker$x_box=15,y_box=15,rows=11
	$	|variable |string |option.object.get
	row
	button |OK |ok |no
	button |Cancel |cancel |no

###################################################################
#
#	component _fopen_bar
#	component _fsave_bar
#
#	Command Bars to be used with a file_open or file_save
#		option (one) containing command. This allows
#		file checking through the standard open and
#		save and saving the file key to the global dict.
#		
###################################################################

component |_fopen_bar
	column |_fopen_bar |_top
	row | |_fopen_bar |5 |5
	button |OK |command.get_option(type='open_file').ok_command |no
		set_tk_config |font:bold
	button |Filter |command.get_option(type='open_file').filter_command |no
		set_tk_config |font:bold
	button |Cancel |cancel |no
		set_tk_config |font:bold
	row |__rest |_top |||top
	column ||__rest

component |_fsave_bar
	column |_fsave_bar |_top
	row | |_fsave_bar |5 |5
	button |OK |command.get_option(type='save_file').ok_command |no
		set_tk_config |font:bold
	button |Filter |command.get_option(type='save_file').filter_command |no
		set_tk_config |font:bold
	button |Cancel |cancel |no
		set_tk_config |font:bold
	row |__rest |_top |||top
	column ||__rest
