#
# Header File for the Commands Module
#	the main component of the tkCoLa
#	graphical user interface generator.
#

import os

# global variable dictionary
global_vars = {}

DEFAULT_COMMANDS_FILE = "Command_Defaults.com"

# Some Fonts
list = '-Adobe-Courier-Medium-R-Normal-*-18-*'
roman = '-Adobe-Courier-Medium-R-Normal-*-14-*'
italic = '-Adobe-Courier-Medium-O-Normal-*-14-*'
bold = '-Adobe-Times-Bold-R-Normal-*-14-*'
boldItalic = '-Adobe-Courier-Bold-O-Normal-*-14-*'

TRUE = 1
FALSE = 0

CANCEL = 0
APPLY = 1
OK = 2

VAL_ERROR = -1

TRUE_LIST = ('yes', 'YES', 'y', 'Y', '1', 'true', 'T', 'TRUE', 'True', 'on', 'ON')
FALSE_LIST = ('no', 'NO', 'n', 'N', '0', 'false', 'F', 'FALSE', 'False', 'off', 'OFF')

INT = ('integer', 'INTEGER', 'int', 'Int', 'INT', 'I', 'i')
FLOAT = ('float', 'FLOAT', 'F', 'f')
STRING = ('string', 'STRING', 'str', 'STR', 'Str', 'S', 's')
LIST = ('list', 'LIST', 'LST', 'lst', 'Lst', 'L', 'l')

UA = 'Up'
DA = 'Down'
RA = 'Right'
LA = 'Left'
ES = 'Escape'
TB = 'Tab'
RT = 'Return'
SP = 'Space'

COLA_KEY_SPECIAL = {UA:UA,DA:DA,RA:RA,LA:LA,ES:ES,TB:TB,RT:RT, 
	'up':UA, 'UP':UA, 'uparrow':UA, 'UPARROW':UA,
	'down':DA, 'DOWN':DA, 'downarrow':DA, 'DOWNARROW':DA,
	'right':RA, 'RIGHT':RA ,'rightarrow':RA, 'RIGHTARROW':RA,
	'left':LA, 'LEFT':LA, 'leftarrow':LA, 'LEFTARROW':LA,
	'esc':ES, 'Esc':ES, 'ESC':ES, 'escape':ES, 'ESCAPE':ES,
	'tb':TB, 'tab':TB, 'TAB':TB,
	'Ret':RT, 'RET':RT, 'ret':RT, 'RETURN':RT,
	'space':SP, 'SPACE':SP, 'sp':SP, 'SP':SP, 'spacebar':SP, 'SpaceBar':SP}

COLA_KEY_CNTRL = ('ct','CT','Ct','cntl','CNTL','Cntl','CTRL','Ctrl',
		'cntrl','CNTRL','Cntrl','control', 'CONTROL', 'Control')
COLA_KEY_ALT = ('alt','Alt','ALT')
COLA_KEY_SHIFT = ('shift','Shift','SHIFT','shft','SHFT')
COLA_KEY_OPTION = ('option','Option','OPTION','opt','OPT','Opt')

COLA_BUTTON = ('but','But','BUT','button','Button','BUTTON')
COLA_DBLBUT = ('dbl','Dbl','DBL','double','Double','DOUBLE')


alias_dict = {
'ok'		:	'manager_ok',
'cancel'	:	'manager_cancel',
'apply'		:	'manager_apply',
'applythen'	:	'manager_applythen',
'OK'		:	'manager_ok',
'CANCEL'	:	'manager_cancel',
'APPLY'		:	'manager_apply',
'APPLYTHEN'	:	'manager_applythen',
'open'		:	'manager_window',
'OPEN'		:	'manager_window',
'menu_init'	:	'self.manager.menu_init',
'menu_groups'	:	'self.manager.menu_set_groups',
'cdo'		:	'command_default_object',
'cro'		:	'command_return_object',
'get_option'	:	'command.get_option'
}

OPTION_ADD = 1
OPTION = 2
COMMAND_ADD = 3
COMMAND = 4
GLOBAL = 5
CASCADE = 6

KEY_ALIAS = {
'pop'		:	'pop',
'pop_menu'	:	'pop',
'popup_menu' 	:	'pop',
'menu_separator':	'menu_sep',
'column'	:	'col',
'import_module'	:	'module',
'import_file'	:	'import',
'var'		:	'set_var',
'multi_list'	:	'list',
'multi_select'	:	'select',
'disable'	:	'set_state',		# no arguments set the state to disabled
'disabled'	:	'set_state',
'reset_tk_config':	'set_tk_config'		# no arguments resets the config to default
}

KEYWORDS = {
'button'		:(OPTION,'Button_Option',None,('*label','*callback','pass_flag','var_name')),
'ok_button'		:(OPTION,'Button_Option',None,('label=\'Ok\'','callback=\'manager.manager_ok\'','pass_flag=0')),
'cancel_button'		:(OPTION,'Button_Option',None,('label=\'Cancel\'','callback=\'manager.manager_cancel\'','pass_flag=0')),
'apply_button'		:(OPTION,'Button_Option',None,('label=\'Apply\'','callback=\'manager.manager_apply\'','pass_flag=0')),
'rebutton'		:(OPTION,'Button_Option',None,('*var_name','*label','*callback',
							'*var_type','*default','pass_flag')),
'button_gen'		:(OPTION,'Button_Generator',None,('*var_name','*label','*callback',
							'*var_type','*default','pass_flag')),
'entry'			:(OPTION,'Entry_Option',None,('*var_name','*label','*var_type','*default')),
'entry_gen'		:(OPTION,'Entry_Generator',None,('*var_name','*label','*var_type','*default')),
'check'			:(OPTION,'Check_Option',None,('*var_name','label','var_type','on_value',
							'off_value','default')),
'link'			:(OPTION_ADD,'add_link',('check',),('on_list','off_list')),
'check_gen'		:(OPTION,'Check_Generator',None,('*var_name','*label','*var_type','*on_value',
							'*off_value','*default')),
'radio'			:(OPTION,'Radio_Option',None,('*var_name','*label','*var_type','*default',
							'orientation')),
'radopt'		:(OPTION_ADD,'option_add',('radio',),('*label','*value')),
'scale'			:(OPTION,'Scale_Option',None,('*var_name','*label','*var_type','*from_val',
							'*to_val','*increment','*default','orientation')),
'list'			:(OPTION,'List_Option',None,('*var_name','*label','*list','var_type','default')),
'select'		:(OPTION,'List_Option',None,('*label','*list','*select_action')),
'menu'			:(OPTION,'Menu_Option',None,('*label','fill_callback','tearoff','var_name')),
'pop'			:(OPTION,'Menu_Option',None,('*var_name','*label','*var_type','callback',
							'default','fill_callback')),
'menu_item'		:(OPTION_ADD,'add_menu_item',('menu','pop'),('*label','value','command','key')),
'menu_sep'		:(OPTION_ADD,'add_menu_separator',('menu','pop'),None),
'open_file'		:(OPTION,'FOpen_Option',None,('*var_name','key','pattern','default',
							'multi_file','path_file')),
'save_file'		:(OPTION,'FSave_Option',None,('*var_name','key','pattern','default',
							'multi_file','path_file')),
'frame'			:(OPTION,'Frame_Option',None,('*label','*fill_callback','var_name','var_type',
							'get_value_callback')),
'text'			:(OPTION,'Text_Option',None,('*label','default','var_name')),
'row'			:(OPTION,'Format_Option',None,('label','in_frame','padx','pady','side')),
'col'			:(OPTION,'Format_Option',None,('label','in_frame','padx','pady','side')),
'row_top'		:(OPTION,'Format_Option',None,('label','in_frame=\"_top\"','padx','pady','side')),
'col_top'		:(OPTION,'Format_Option',None,('label','in_frame=\"_top\"','padx','pady','side')),
'callback'		:(OPTION_ADD,'make_callback',None,('*callback', 'pass_flag')),
'set_state'		:(OPTION_ADD,'set_state',None,('state',)),
'color_default'		:(OPTION_ADD,'set_color_default',
				('rebutton','entry','button_gen','entry_gen','select','list','pop','frame'),('where',)),

'command'		:(COMMAND,'Command_Record',None,('*title','*command','scope','mkey')),
'dialog'		:(COMMAND,'Command_Record',None,('*title','*command','scope','mkey','return_mode=TRUE')),
'command_set'		:(COMMAND,'Command_Record',None,('*title',)),
'insert_component'	:(COMMAND_ADD,'insert_component',None,('*component',)),
'default_callback'	:(COMMAND_ADD,'default_callback_set',None,('*default_callback','refresh_callback')),
'command_flag'		:(COMMAND_ADD,'add_command_flag',None,('*flag_object',)),
'post_command'		:(COMMAND_ADD,'add_post_command',None,('*command','pass_flag')),
'label'			:(COMMAND_ADD,'label_set',None,('*label',)),
'static'		:(COMMAND_ADD,'static_add',None,('*var_val',)),
'group'			:(COMMAND_ADD,'add_group',None,('*group_name',)),
'bind_all'		:(COMMAND_ADD,'set_binding',None,('*event', '*callback')),
'bind_top'		:(COMMAND_ADD,'set_binding',None,('*event', '*callback', 'top=TRUE')),
'component'		:(GLOBAL,'add_component',None,('*title',)),
'group_range'		:(GLOBAL,'add_range',None,('*range',)),
'module'		:(GLOBAL,'add_module',None,('*module',)),
'import'		:(GLOBAL,'add_file',None,('*filename',)),
'prefix'		:(GLOBAL,'add_prefix',None,('*prefix',)),

'set_var'		:(CASCADE,'add_var',None,('*var_name', '*value')),
'set_tk_config'		:(CASCADE,'set_tk_config',None,('tk_config',)),
'add_tk_config'		:(CASCADE,'add_tk_config',None,('*tk_config',)),
'bind'			:(CASCADE,'set_binding',None,('*event', '*callback'))
}

TK_VERT  = ('vert','V','v','VERT','vertical','VERTICAL')
TK_HORIZ = ('horiz','H','h','HORIZ','horizontal','HORIZONTAL')

TK_FOREGROUND = ('f','F','fd','FD','fore','FORE','foreground','FOREGROUND')
TK_BACKGROUND = ('b','B','bd','BD','back','BACK','background','BACKGROUND')

TK_ENABLED = ('e','n','E','N','enable','norm','normal','enabled','NORM','NORMAL','ENABLE','ENABLED')
TK_DISABLED = ('d','D','disable','disabled','DISABLE','DISABLED')

TK_INACTIVE = 'grey'

TK_SIDES = {
'left'		:	('left','l','L','Left','LEFT'),
'right'		:	('right','r','R','Right','RIGHT'),
'top'		:	('top','t','T','Top','TOP'),
'bottom'	:	('bottom','b','B','bot','Bottom','BOTTOM')
}

# Default color map
colors = (	'',		# transparent
		'black',
		'gray10',
		'gray20',
		'gray30',
		'gray40',
		'gray50',
		'gray60',
		'gray70',
		'gray80',
		'gray90',
		'white',
		'red',
		'OrangeRed',
		'orange',
		'goldenrod',
		'yellow',
		'YellowGreen',
		'green',
		'cyan',
		'LightBlue',
		'blue',
		'BlueViolet',
		'purple')
