#!/usr/bin/env python
#	
#	Command_Script: A module to allow scripting of
#		commands and editing of scripts.
#		  Part of the tkCoLa suite.
#		  See documentation for details of use.
#		  Version 1.0, August 16, 2000, 5-ish
#
#		JEMWorks Software, 2000
#		http://www.jasonya.com/jemworks
#		jemworks@jasonya.com
#
#	tkCoLa: Tkinter Command Language
#		A mini-language which provides a simplified
#		interface to Tk widgets and allows rapid
#		prototyping of command interfaces and other
#		GUIs in Python.	
#

import string
import FileDialog
import os
import sys
import copy
import tkFont

from Dialog import Dialog
from types import *

from Command_Init import *

# FIXME: kludged the directory specification
try:
	SRC_DIR = os.environ['COMMAND_SRC']
except KeyError:
	SRC_DIR = ''

#
# class Command_Scripts_Manager
#
# 	A class to work with the Command_Struct manager
# 	to allow recording scripts composed of multiple
#	commands, execution of these scripts, and
#	editing of the scripts.
#
#	manager:	the parent command_struct
#

class Command_Scripts_Manager:
	def __init__(self, manager):
		self.manager = manager
		
		# are we currently recording?
		self.recording = FALSE
		
		self.script_list = []
		
#
# class Command_Script
#
#	Class of the command script itself.
#	
#	title:		title for the script
#		
#
#
#
class Command_Script:
	def __init__(self, title):
		self.title = title
		
		# list of the commands in the script
		self.commands_list = []

	def add_command(self, scob):
		self.commands_list.append(scob)

#
# class Script_Object
#
#	A command reference for scripting.
#		keeps a reference to the command
#		and a snapshot dictionary of
#		values for the commands variables
#		at the time the script was recorded.
#	
#	command:	reference to the Command instance
#	com_script:	the parent command script
#	var_dict:	the dictionary of values from the command
#			if not given, we'll attempt to get them
#			from the command reference.
#

class Script_Object:
	def __init__(self, command, com_script, var_dict=None):
		self.command = command
		self.title = command.title
		self.com_script = com_script
		
		if var_dict:
			self.var_dict = var_dict
		else:
			self.var_dict = command.get_value_dict()
		
