#	
#	Format_Commands.py
#		A python plugin module for use with the
#		Aph_Edit Command structure.
#		
#		This module handles file conversions
#		which are non-standard.
#	
#	
#	Jason McDermott 2/24/00, mcdermoj@ohsu.edu
#	
#	

import string
import FileDialog
import os

from Aph_Format import *

def mtz_convert(parent=None, hklout=None, title=None, alng=None, blng=None,
		thick=None, acangle=None, bcangle=None, 
		abangle=None, space=None, weight=None, sigmas=None, 
		**kw):
	if not parent:
		return

	if not parent.aph_record:
		return
	
	aph_record = parent.aph_record
	
	if aph_record.type != 'hkl':
		print 'MTZ Convert Error: Not an HKL File'
		return
	
	# make a script to run f2mtz
	# FIXME: really we should just write out the file
	# in the appropriate format, maybe later :)
	comfile = 'MTZCONVERT.COM'
	tempfile = 'TEMP.HKL'
	
	# output the hkl file in a pre-mtz format
	try:	
	    fd = open(tempfile, 'w')
	    # Write the file
	    aph_record.output(fd, format=parent.output_format,
	    			order=EXPORT_MTZ, header_out=0)
	    fd.close()
	    
	except IOError:
	    print 'MTZ Convert Error: Unable to create file'
	    return 0
	
	fd = open(comfile, 'w')
	
	fd.write('#!/bin/sh\n')
	fd.write('f2mtz HKLIN %s HKLOUT %s << eof\n' % (tempfile, hklout))
	fd.write('TITLE %s \n' % title)
	fd.write('CELL %5.2f %5.2f %5.2f %5.2f %5.2f %5.2f \n' %
		(alng, blng, thick, acangle, bcangle, abangle))
	fd.write('SYMMETRY %s \n' % space)
	fd.write('LABOUT H K L FC PC SIGFC SIGPC FOMC \n')
	fd.write('CTYPOUT H H H F P Q Q W \n')
	fd.write('END \n')
	fd.write('eof \n')
	fd.close()
	
	os.chmod(comfile, string.atoi('777',8))
	os.system(comfile)
	
