# Default commands and components for the Graph Module

# default button style for standard graph options
var |_graph_button_config |{'font':bold,'background':'LightSalmon2',
			$ 'foreground':'maroon', 'width':10}
# button style for extra options
var |_option_button_config |{'font':bold,'background':'PaleGreen2',
			$ 'foreground':'DarkSeaGreen4','width':10}

component |legend_button
	button |Legend |manager_window$command_title='Legend Options', 
		$ window_config='def', data=self.data
	set_tk_config |$_graph_button_config
component |data_button
	button |Data |manager_window$command_title='Data Options',
		$ window_config='def', data=self.data
	set_tk_config |$_graph_button_config
component |select_button
	button |Select |manager_window$command_title='Select Data',
		$ window_config='def', data=self.data
	set_tk_config |$_graph_button_config
component |graph_button
	button |Graph |manager_window$command_title='Graph Options',
		$ window_config='def', data=self.data
	set_tk_config |$_graph_button_config
component |post_button
	button |Postscript |manager_window$command_title='Export Postscript',
		$ window_config='def', data=self.data
	set_tk_config |$_graph_button_config
component |close_button
	button |Close |cancel |no
	set_tk_config |$_graph_button_config	

component |simple_bar
	column |_command_bar |_top | | |bottom
	row | |_command_bar |5
	button |OK |ok |no
	set_tk_config |font:bold
	button |Cancel |cancel |no
	set_tk_config |font:bold
	row |rest |_top |||top
	column ||rest

# 'option' should be passed as the data to this window	
command |Color Picker |command_return_object$objects=self.data
	default_callback |command_default_object$objects=self.data
	frame |color_picker |Color_Picker$x_box=15,y_box=15,rows=11
	$	|variable |string |option.object.picked_color
	row
	button |OK |ok |no
	button |Cancel |cancel |no
	post_command |self.data.alias_config$alias_dict={'variable':'background'} |true

component |command_bar
	column |_command_bar |_top | | |bottom
	row | |_command_bar |5
	button |OK |ok |no
	set_tk_config |font:bold
	button |Apply |apply |no
	set_tk_config |font:bold
	button |Cancel |cancel |no
	set_tk_config |font:bold
	row |rest |_top |||top
	column ||rest
	
component |graph_bar
	column |_graph_bar | |2 |3
	insert_component |legend_button
	insert_component |data_button
	insert_component |select_button
	insert_component |graph_button
	insert_component |post_button
	insert_component |close_button
	column |_user_bar |_graph_bar
	
component |graph_window
	row |_graph_window |_top ||5 |top
	frame |graph_record |self.data._make_graph
	insert_component |graph_bar
	row |_user_space |_top ||5 |bottom
	
command_set |Graph Window
	insert_component |graph_window
	
command |Legend Options |command_return_object$objects=self.data.legend
	default_callback |command_default_object$objects=self.data.legend
	
	row |A |_top
	column ||A
	check |hide |Hide Legend |int |1 |0 |off
	entry |x_loc |Legend X Coordinate |int |300
	entry |y_loc |Legend Y Coordinate |int |30
	entry |title |Legend Title |string |
	entry |header |Box Header |string |
	entry |symbol_size |Symbol Size |int |8
	column ||A
	rebutton |bg_color |Background Color
		$ |manager_window$command_title='Color Picker',
		$ window_config='def', data=option |string ||no
		add_tk_config |width:14
		color_default
	rebutton |font_color |Foreground Color
		$ |manager_window$command_title='Color Picker',
		$ window_config='def', data=option |string ||no
		add_tk_config |width:14
		color_default
	rebutton |bg_outline |Outline Color
		$ |manager_window$command_title='Color Picker',
		$ window_config='def', data=option |string ||no
		add_tk_config |width:14
		color_default
	row ||_top |||bottom
	insert_component |command_bar

	post_command |self.data._update |no

command |Data Options |self.data.set_datalist
	row |A |_top
	column |B |A ||9
	text |Show
	check_gen |in_graph ||int |1 |0 
		$ |self.data.datalist$in_graph
	column |C |A
	text |Entry
	entry_gen |title | |string
		$ |self.data.datalist$title
	column |D |A
	text |Color
	button_gen |color |Color |manager_window$command_title='Color Picker',
		$ window_config='def', data=option |string 
		$ |self.data.datalist$color |no
		color_default
	row |N |_top
	insert_component |command_bar
	
	post_command |self.data._update |no
	
command_set |Select Data
	multi_select |Testing |self.data.datalist$title 
		$ |self.data._select_member
	button |Close |cancel |no
	
command |Graph Options |command_return_object$objects=self.data
	default_callback |command_default_object$objects=self.data
	
	rebutton |bg_color |Background Color
		$ |manager_window$command_title='Color Picker',
		$ window_config='def', data=option |string ||no
		add_tk_config |width:14
		color_default
	rebutton |graph_color |Graph Color
		$ |manager_window$command_title='Color Picker',
		$ window_config='def', data=option |string ||no
		add_tk_config |width:14
		color_default
	scale |symbol_size |Symbol Size |int |1 |10 |1 |2
	
	insert_component |command_bar
	post_command |self.data._update |no

command |Export Postscript |self.data._save_paper
	save_file |filename |export_ps |*.ps |lattice_line.ps
	check |all_data |Export All Data |int |1 |0 |off
	insert_component |_fsave_bar

##############################################################################

component |m_legend_button
	button |Legend |manager_window$command_title='Legend_Options', 
		$ window_config='def', data=self.data
	set_tk_config |$_graph_button_config
component |m_data_button
	button |Data |manager_window$command_title='Data_Options',
		$ window_config='def', data=self.data
	set_tk_config |$_graph_button_config
component |m_select_button
	button |Select |manager_window$command_title='Select_Data',
		$ window_config='def', data=self.data
	set_tk_config |$_graph_button_config
component |m_graph_button
	button |Graph |manager_window$command_title='Graph_Options',
		$ window_config='def', data=self.data
	set_tk_config |$_graph_button_config
	
component |m_graph_bar
	column |_m_graph_bar | |2 |3
	insert_component |m_legend_button
	insert_component |m_data_button
	insert_component |m_select_button
	insert_component |m_graph_button
	insert_component |post_button
	insert_component |close_button
	column |_user_bar |_m_graph_bar
	
component |m_graph_window
	row |_m_graph_window |_top ||5 |top
	frame |graph_record |self.data._m_make_graph
	insert_component |m_graph_bar
	row |_user_space |_top ||5 |bottom
	
command_set |MultiPane Graph Window
	insert_component |m_graph_window
	
command |Legend_Options |command_return_object$objects=self.data.legend
	default_callback |command_default_object$objects=self.data.legend
	
	row |A |_top
	column ||A
	check |hide |Hide Legend |int |1 |0 |off
	entry |x_loc |Legend X Coordinate |int |300
	entry |y_loc |Legend Y Coordinate |int |30
	entry |title |Legend Title |string |
	entry |header |Box Header |string |
	entry |symbol_size |Symbol Size |int |8
	column ||A
	rebutton |bg_color |Background Color
		$ |manager_window$command_title='Color Picker',
		$ window_config='def', data=option |string ||no
		add_tk_config |width:14
		color_default
	rebutton |font_color |Foreground Color
		$ |manager_window$command_title='Color Picker',
		$ window_config='def', data=option |string ||no
		add_tk_config |width:14
		color_default
	rebutton |bg_outline |Outline Color
		$ |manager_window$command_title='Color Picker',
		$ window_config='def', data=option |string ||no
		add_tk_config |width:14
		color_default
	row ||_top |||bottom
	insert_component |command_bar

	post_command |self.data._m_update |no

command |Data_Options |self.data.m_set_datalist
	row |A |_top
	column |B |A ||9
	text |Show
	check_gen |in_graph ||int |1 |0 
		$ |self.data.datalist$in_graph
	column |C |A
	text |Entry
	entry_gen |title | |string
		$ |self.data.datalist$title
	column |D |A
	text |Color
	button_gen |color |Color |manager_window$command_title='Color Picker',
		$ window_config='def', data=option |string 
		$ |self.data.datalist$color |no
		color_default
	row |N |_top
	insert_component |command_bar
	
	post_command |self.data._m_update |no
	
command_set |Select_Data
	multi_select |Testing |self.data.datalist$title 
		$ |self.data._m_select_member
	button |Close |cancel |no
	
command |Graph_Options |command_return_object$objects=self.data
	default_callback |command_default_object$objects=self.data
	
	rebutton |bg_color |Background Color
		$ |manager_window$command_title='Color Picker',
		$ window_config='def', data=option |string ||no
		add_tk_config |width:14
		color_default
	rebutton |graph_color |Graph Color
		$ |manager_window$command_title='Color Picker',
		$ window_config='def', data=option |string ||no
		add_tk_config |width:14
		color_default
	scale |symbol_size |Symbol Size |int |1 |10 |1 |2
	
	insert_component |command_bar
	post_command |self.data._update |no


