#	
#	
#	Jason McDermott 6/25/99, mcdermoj@ohsu.edu
#	
#	
#	

import string, os, sys
import FileDialog

from Tkinter import *
from Dialog import Dialog

roman = '-Adobe-Courier-Medium-R-Normal-*-14-*'
italic = '-Adobe-Courier-Medium-O-Normal-*-14-*'
bold = '-Adobe-Courier-Bold-R-Normal-*-14-*'
boldItalic = '-Adobe-Courier-Bold-O-Normal-*-14-*'

header = '-Adobe-Courier-Bold-R-Normal-*-20-*'
title = '-Adobe-Courier-Bold-R-Normal-*-18-*'
body = '-Adobe-Courier-Medium-R-Normal-*-18-*'
italic2 = '-Adobe-Courier-Medium-O-Normal-*-18-*'
secTitle = '-Adobe-Courier-Bold-R-Normal-*-24-*'

scrollbarWidth = 10
HEIGHT = 35

# Predefined Tags for the help file
Help_Tags = ['\"secTitle\", font=secTitle, foreground=\"blue\", underline=1, justify=CENTER',
	     '\"sub\", font=header, rmargin=50',
	     '\"normal\", font=body, wrap=\"word\"',
	     '\"center\", font=body, justify=CENTER, wrap=\"word\", rmargin=50',
	     '\"hang\", font=body, lmargin1=0, lmargin2=60, wrap=\"word\", rmargin=50',
	     '\"paragraph\", font=body, lmargin1=60, lmargin2=0, wrap=\"word\", rmargin=50',
	     '\"indent\", font=body, lmargin1=60, lmargin2=60, wrap=\"word\", rmargin=50']

class HelpWindow(Frame):
	def __init__(self, master, file):
		Frame.__init__(self,master)
		self._top = master
		self.file = file
		
                self.body(master)
		self.pack()
		self.winfo_toplevel().title('Help File: ' + file)
		
	def body(self, master):
		self._indexFrame = Frame(master, height=HEIGHT)
		self._indexFrame.pack(side='left', fill='y', expand=1)
		self.createButtons(self._indexFrame)
		self.createIndex(self._indexFrame)
		self.createText(master)
		
		self.open_file(self.file)
	
	def createButtons(self, master):
		self._buttonbar1 = Frame(master)
		self._buttonbar1.pack({'side':'bottom'})
		self._closebutton = Button(self._buttonbar1, {'text':'Close Help',
						'command':self.close})
		self._closebutton.pack({'side':'left'})
		
		self._buttonbar2 = Frame(master)
		self._buttonbar2.pack({'side':'bottom'})
		self._firstbutton = Button(self._buttonbar2, {'text':' << ',
						'command':self.firstPage})
		self._firstbutton.pack({'side':'left'})
		self._prevbutton = Button(self._buttonbar2, {'text':'< Prev',
						'command':self.prevPage})
		self._prevbutton.pack({'side':'left'})
		self._nextbutton = Button(self._buttonbar2, {'text':'Next >',
						'command':self.nextPage})
		self._nextbutton.pack({'side':'left'})
		self._lastbutton = Button(self._buttonbar2, {'text':' >> ',
						'command':self.lastPage})
		self._lastbutton.pack({'side':'left'})
		
	def createIndex(self, master):
		index_frame = Frame(master)
		index_frame.pack(side='left', fill='both', expand=1)
		self._list_scroll=Scrollbar(index_frame, width=scrollbarWidth)
		self._list_scroll.pack({'side': 'left', 'fill': 'y','expand' : 'yes'})
		
		self._indexList = Listbox(index_frame, relief='groove', font=header,
					exportselection=0, background='LightSteelBlue1')
		self._indexList.pack({'side':'left', 'fill':'both', 'expand':1})
		
		self._indexList['yscrollcommand'] = (self._list_scroll, 'set')
		self._list_scroll['command'] = (self._indexList, 'yview')

		self._indexList.bind('<ButtonRelease-1>', self.select_action)
		self._indexList.bind('<KeyRelease-Up>', self.select_action)
		self._indexList.bind('<KeyRelease-Down>', self.select_action)
		
		
	def createText(self, master):
			 
		self._textArea=Text(master, height=HEIGHT)
	      	self._textArea.pack({'side': 'left', 'fill': 'x','expand' : 'yes'})
	      	self._scrollBar=Scrollbar(master, {'width':scrollbarWidth})
		self._scrollBar.pack({'side': 'right', 'fill': 'y','expand' : 'yes'})
		self._textArea['yscrollcommand'] = (self._scrollBar, 'set')
		self._scrollBar['command'] = (self._textArea, 'yview')
		
		# add text tags
		for tag in Help_Tags:
			eval(('self._textArea.tag_config('+ tag +')'))
		
		self._textArea.tag_config("link", font=header, foreground="red", underline=1, wrap="word")
		self._textArea.tag_bind('link', '<Enter>', self.show_hand_cursor)
		self._textArea.tag_bind('link', '<Leave>', self.show_arrow_cursor)
		self._textArea.tag_bind('link', '<Button-1>', self.hyperlink)
		self.show_arrow_cursor() 	
		
	def hyperlink(self, event=None):
		# find text
		index = '@%d,%d' % (event.x, event.y)
		index = event.widget.index(index)
		tag = event.widget.tag_names(index)
		
		trange = event.widget.tag_ranges(tag)
		
		for i in range(len(trange)/2):
			if (index > trange[i*2]) and (index < trange[i*2+1]):
				break
			
		tag_text = event.widget.get(trange[i*2],trange[i*2+1])
			
		link = self.sectDict[tag_text].link
		n = 0
		for i in self.sectionList:
			if i.title == link:
				self.display_page(n)
			n = n + 1	
	def show_arrow_cursor(self, event=None):
		self._textArea['cursor']="arrow" 
	def show_hand_cursor(self, event=None):
		self._textArea['cursor']="hand2"
			
	def openHelp(self):
		pass
		
	def close(self):
		self._top.destroy()
		
	def firstPage(self):
		self.display_page(0)
		
	def prevPage(self):
		sel = self._indexList.curselection()
		if len(sel) == 0:
		    return
		try:
		    n = string.atoi(sel[0])
		except ValueError:
		    n = sel
		if n == 0:
		    return
		    
		self.display_page(n-1)
		    
	def nextPage(self):
		sel = self._indexList.curselection()
		if len(sel) == 0:
		    return
		try:
		    n = string.atoi(sel[0])
		except ValueError:
		    n = sel
		if n == self._indexList.size() - 1:
		    return
		    
		self.display_page(n+1)
		 
	def lastPage(self):
		n = self._indexList.size() - 1
		self.display_page(n)
		
	def select_action(self, event):
		sel = self._indexList.curselection()
		if len(sel) == 0:
			return
		try:
		    n = string.atoi(sel[0])
		except ValueError:
		    self.display_page(sel)
		    
		self.display_page(n)
		
	def display_page(self, number=0):
		self._indexList.select_clear(0, self._indexList.size())
		self._indexList.select_set(number)
		self.sectionList[number].display(self._textArea)
		
	def open_file(self, file):
		
		self.sectionList = []
		blockList = []
		self.sectDict = {}
		
		# user font dictionary
		self.fontDict = {}
		font = self.fontDict
		
		# This will locate the help file
		# as long as it resides in the
		# same directory as the main executable.
		path = os.path.join(sys.path[0], file)

		try:
		    fd = open(path, 'r')
		    lines = fd.readlines()
		    fd.close()
		except IOError:
		    self.close()
		
		first = 1
		
		for l in lines:
		    if l[0] == '\\':
			ls = string.split(l, None, 1)
			    
		#############################
		# Special action tags
		#############################			
			if (ls[0] == '\\sect'):
			    if not first:
			    	blockList.append(Block(text, tag))
				self.sectionList.append(Help_Entry(title, blockList))
				self._indexList.insert(END, title)
			    first = 0
			    del blockList
			    blockList = []
			    title = string.rstrip(ls[1])
			    blockList.append(Block(title + '\n', 'secTitle'))
			    tag = 'normal' # default after section heading
			    text = ''
			    continue
			if ls[0] == '\\sub':
			    blockList.append(Block(text, tag))
			    text = '\n\n' + ls[1]
			    tag = ls[0][1:]
			    blockList.append(Block(text, tag))
			    text = ''
			    tag = 'paragraph'	# default after sub heading
			    continue
			if ls[0] == '\\link':
			    savetag = tag
			    text = text + ' '
			    blockList.append(Block(text, tag))
			    split = string.split(ls[1], '|')
			    text = string.strip(split[0])
			    link = string.strip(split[1])
			    tag = ls[0][1:]
			    block = Block(text, tag, link)
			    blockList.append(block)
			    self.sectDict[text] = block
			    text = ''
			    tag = savetag
			    continue
			if ls[0] == '\\ret':
			    text = text + '\n'
			    continue
			    
		#############################
		# User defined variables
		#############################
			# add a user defined text tag
			if ls[0] == '\\tag':
			    # split off next token, tag name
			    n = string.split(ls[1], None, 1)
			    tag_name = '\"' + n[0] + '\", '	#enclose in quotes
			    tag_def = string.strip(n[1])
			    tag_init = 'self._textArea.tag_config('
			    tag_end = ')'
			    eval(tag_init + tag_name + tag_def + tag_end)
			    text = ''
			    tag = tag_name
			    continue
			    
			# add a user defined font
			if ls[0] == '\\font':
			    # split off next token, font name
			    n = string.split(ls[1], None, 1)
			    font_name = n[0]			#enclose in quotes
			    font_def = string.strip(n[1])
			    font[font_name] = font_def
			    text = ''
			    tag = 'paragraph'
			    continue
			    
			else:
			    blockList.append(Block(text, tag))
			    text = ''
			    tag = ls[0][1:]	# strip leading \ char
			    continue
		    if l == '\n':
		    	text = text + '\n\n'
		    else:
			text = text + ' ' + string.strip(l)
		    
		blockList.append(Block(text,tag))
		self.sectionList.append(Help_Entry(title, blockList))
		self._indexList.insert(END, title)
		
		self.display_page(0)
							
	def del_text(self):
		self._textArea.delete("1.0", END)
		
	def set_text(self, text, tag=None):
		self._textArea.delete("1.0", END)
		self._textArea.insert(END, text, tag)
	
	def get_text(self):
		return self._textArea.get("1.0", END)
	
	def add_text(self, text, tag=None):
		self._textArea.insert(END, text, tag)
		
class Help_Entry:
	def __init__(self, title, blockList):
		self.title = title
		self.blockList = blockList
		
	def display(self, viewer):
		viewer['state']='normal'
		viewer.delete("1.0", END)
		for d in self.blockList:
			d.add(viewer)
		viewer['state']='disabled'
		
class Block:
	def __init__(self, text, tag, link={}):
		self.text = text
		self.tag = tag
		self.link = link
	
	def add(self, viewer):
		viewer.insert(END, self.text, self.tag)



